//Motor PIN
#include "WProgram.h"
int Ping(int time);
void Serial_gets(char *buf,char sw);
void setup();
void motor_move1(int val);
void motor_move2(int val);
void Turn_R(int val);
void Turn_L(int val);
void Back(int val);
void Go(int val);
void Stop();
void loop();
int M1_in1 =3;
int M1_in2 =11;
int M2_in1 =9;
int M2_in2 =10;

//Ping PIN
int SIG = 4;

//Robot Speed
int Speed=0;

//Serial
char str[20];
char val;

//Ping
unsigned long PW = 0;

int Ping(int time) {
//make SIG PIN OUT mode
  pinMode(SIG, OUTPUT);
  //2ms dumy wait
  digitalWrite(SIG, LOW);
  delayMicroseconds(2);
  //make Triger
  digitalWrite(SIG, HIGH);
  delayMicroseconds(5);
  //Triger end
  digitalWrite(SIG, LOW);
  delayMicroseconds(350);
  //make SIG PIN input mode
  pinMode(SIG, INPUT);
  //\u4fe1\u53f7\u30d4\u30f3\u3092HIGH\u306b\u8a2d\u5b9a
  //digitalWrite(SIG, HIGH);
  //\u53cd\u5c04\u6ce2\u304c\u623b\u3063\u3066\u304f\u308b\u307e\u3067\u306e\u6642\u9593\u3092\u8a08\u6e2c\u3057
  //\u7247\u9053\u306e\u6642\u9593\uff08\u534a\u5206\u306e\u5024\uff09\u306b\u3059\u308b
  PW = pulseIn(SIG, HIGH);
  //\u30df\u30ea\u30e1\u30fc\u30c8\u30eb\u5358\u4f4d\u306b\u5909\u63db
  int Length = (float)PW*0.34442/2.0;

  //\u8ddd\u96e2\u3092\u51fa\u529b
  //Serial.println( Length);
  delay(time);
  return(Length);
}

void Serial_gets(char *buf,char sw)
{
  int i = 0;
  char c;
  while (1) {
    if (Serial.available()) {
      c = Serial.read();
      //Serial.println(c);
      buf[i] = c;
      if (c == sw) break; // \u6587\u5b57\u5217\u306e\u7d42\u308f\u308a\u5224\u65ad
      i++;
    }
  }
  buf[i] = '\0';
}

void setup() {
  Serial.begin(38400); // \u30b7\u30ea\u30a2\u30eb\u30dd\u30fc\u30c8\u309238400bps\u3067\u958b\u304f
}

void motor_move1(int val) {
  if(val>0) {
  analogWrite(M1_in1,abs(val));
  analogWrite(M1_in2,0);
  }
  if(val<0) {
  analogWrite(M1_in2,abs(val));
  analogWrite(M1_in1,0);
  }
  if(val==0) {
  analogWrite(M1_in2,255);
  analogWrite(M1_in1,255);
  }
}

void motor_move2(int val) {
  if(val>0) {
  analogWrite(M2_in1,abs(val));
  analogWrite(M2_in2,0);
  }
  if(val<0) {
  analogWrite(M2_in2,abs(val));
  analogWrite(M2_in1,0);
  }
  if(val==0) {
  analogWrite(M2_in2,255);
  analogWrite(M2_in1,255);
  }
}

void Turn_R(int val) {
  motor_move1(val);
  motor_move2(-val);
}
void Turn_L(int val) {
  motor_move1(-val);
  motor_move2(val);
}

void Back(int val) {
  motor_move1(-val);
  motor_move2(-val);
}

void Go(int val) {
  motor_move1(val);
  motor_move2(val);
}

void Stop() {
  motor_move1(0);
  motor_move2(0);
}

void loop() {
  int i;
  char dmy[5];
  char dmy_format[100];
  
  Serial.print("->\n");
  if (Serial.available()) {
  Serial_gets(str,'\n');
  }
  Serial.println(str);
  val = str[0];
  int Length;
  Length =Ping(200);//Ping\u8ddd\u96e2\u8a08
  
  //Arduino\u9001\u4fe1\u30d5\u30a9\u30fc\u30de\u30c3\u30c8
  sprintf(dmy_format,"%d,%d,%d\n",Length,Length,Length);
  Serial.print(dmy_format);
  //Speed
  if(val == 's') {
    dmy[0]=str[1];
    dmy[1]=str[2];
    dmy[2]=str[3];
    dmy[3]='\0';
    Speed=atoi(dmy);
  }
  //Left or Rigt
  if(val == 'R') {
  Turn_R(Speed);
  }
  if(val == 'L') {
  Turn_L(Speed);
  }
  //back or go
  if(val == 'G') {
  Go(Speed);
  }
  if(val == 'B') {
  Back(Speed);
  }
  //Stop
  if(val == 'S') {
  Stop();
  }
}

int main(void)
{
	init();

	setup();
    
	for (;;)
		loop();
        
	return 0;
}

