//Motor PIN
int M1_in1 =3;
int M1_in2 =11;
int M2_in1 =9;
int M2_in2 =10;

//Ping PIN
int SIG = 4;

//Robot Speed
int Speed=0;

//Serial
char str[20];
char val;

//Ping
unsigned long PW = 0;

int Ping(int time) {
//make SIG PIN OUT mode
  pinMode(SIG, OUTPUT);
  //2ms dumy wait
  digitalWrite(SIG, LOW);
  delayMicroseconds(2);
  //make Triger
  digitalWrite(SIG, HIGH);
  delayMicroseconds(5);
  //Triger end
  digitalWrite(SIG, LOW);
  delayMicroseconds(350);
  //make SIG PIN input mode
  pinMode(SIG, INPUT);
  //信号ピンをHIGHに設定
  //digitalWrite(SIG, HIGH);
  //反射波が戻ってくるまでの時間を計測し
  //片道の時間（半分の値）にする
  PW = pulseIn(SIG, HIGH);
  //ミリメートル単位に変換
  int Length = (float)PW*0.34442/2.0;

  //距離を出力
  //Serial.println( Length);
  delay(time);
  return(Length);
}

void Serial_gets(char *buf,char sw)
{
  int i = 0;
  char c;
  while (1) {
    if (Serial.available()) {
      c = Serial.read();
      //Serial.println(c);
      buf[i] = c;
      if (c == sw) break; // 文字列の終わり判断
      i++;
    }
  }
  buf[i] = '\0';
}

void setup() {
  Serial.begin(38400); // シリアルポートを38400bpsで開く
}

void motor_move1(int val) {
  if(val>0) {
  analogWrite(M1_in1,abs(val));
  analogWrite(M1_in2,0);
  }
  if(val<0) {
  analogWrite(M1_in2,abs(val));
  analogWrite(M1_in1,0);
  }
  if(val==0) {
  analogWrite(M1_in2,255);
  analogWrite(M1_in1,255);
  }
}

void motor_move2(int val) {
  if(val>0) {
  analogWrite(M2_in1,abs(val));
  analogWrite(M2_in2,0);
  }
  if(val<0) {
  analogWrite(M2_in2,abs(val));
  analogWrite(M2_in1,0);
  }
  if(val==0) {
  analogWrite(M2_in2,255);
  analogWrite(M2_in1,255);
  }
}

void Turn_R(int val) {
  motor_move1(val);
  motor_move2(-val);
}
void Turn_L(int val) {
  motor_move1(-val);
  motor_move2(val);
}

void Back(int val) {
  motor_move1(-val);
  motor_move2(-val);
}

void Go(int val) {
  motor_move1(val);
  motor_move2(val);
}

void Stop() {
  motor_move1(0);
  motor_move2(0);
}

void loop() {
  int i;
  char dmy[5];
  char dmy_format[100];
  
  Serial.print("->\n");
  //シリアルに信号がきたらシリアルで文字列を読む
  if (Serial.available()) {
  Serial_gets(str,'\n');
  }
  Serial.println(str);
  val = str[0];
  int Length;
  Length =Ping(200);//Ping距離計
  
  //Arduino送信フォーマット
  sprintf(dmy_format,"%d,%d,%d\n",Length,Length,Length);
  Serial.print(dmy_format);
  //Speed
  if(val == 's') {
    dmy[0]=str[1];
    dmy[1]=str[2];
    dmy[2]=str[3];
    dmy[3]='\0';
    Speed=atoi(dmy);
  }
  //Left or Rigt
  if(val == 'R') {
  Turn_R(Speed);
  }
  if(val == 'L') {
  Turn_L(Speed);
  }
  //back or go
  if(val == 'G') {
  Go(Speed);
  }
  if(val == 'B') {
  Back(Speed);
  }
  //Stop
  if(val == 'S') {
  Stop();
  }
}
