//ロボットコントローラインターフェイス
import controlP5.*;//GUI LIB
import processing.serial.*;//Serial LIB
import processing.video.*;//video

ControlP5 controlP5;//GUI オブジェクト
Serial myPort;//シリアルオブジェクト
Capture myCapture;//ビデオキャプチャーオブジェクトビデオを使うならコメントを外す

String Cmd     = "Start";//Arduinoに送るコマンド
String Cmd_old = "";//Arduinoに送ったコマンド

int Sx,Sy,Sz;//Arduinoより贈られるセンサーのデータ

int myColorBackground = color(0,0,0);//バックグラウンドカラーを黒とする．

void setup() {
  size(400,400);//windowのサイズ
  frameRate(30);//表示切替時間間隔
  controlP5 = new ControlP5(this);//クラスのコピー
  myPort = new Serial(this,"COM1",38400);//使うcomポート 必ずチェック＆大文字で書くこと
 int i;
 int bx,by;//ボタンサイズ
 int bwx,bwy;//ボタンコントローラの表示開始位置
 bwx=10;
 bwy=250;
 bx=by=35;
 //control interface GUI
 //GUI部品にidを設定
 controlP5.addSlider("SPEED",0,255,100,150+bwx,50+bwy,100,20).setId(5);
 //slider function name,start V,end V,set start V,x,y,w,h,slide H)
 //function slider <- Slider val
      i=0;//前進GO
      controlP5.addBang("G",50+bwx,0+bwy,bx,by).setId(i);
                      //(nama,x,y,dx,dy).ID
      i=1;//左回転Left
      controlP5.addBang("L",0+bwx,50+bwy,bx,by).setId(i);
      i=2;//停止
      controlP5.addBang("S",50+bwx,50+bwy,bx,by).setId(i);
      i=3;//右回転
      controlP5.addBang("R",100+bwx,50+bwy,bx,by).setId(i);
      i=4;//バック
      controlP5.addBang("B",50+bwx,100+bwy,bx,by).setId(i);
      
myCapture = new Capture(this, 280, 210, 30);    //ビデオのキャプチャー実行，ビデオを使うならコメントを外す,取得サイズ280,210ピクセル
}

void draw() {
  String dmy;//画面表示用文字列作成文字列
  background(myColorBackground);//背景を黒にする．これは毎回行わないと過去に画面に描いたものが残る
  //シリアルに毎回データを送りまくるのはエレガントでないので値の更新があったときのみ送信
  if(Cmd.equals(Cmd_old)) {  
  } else {
    println(Cmd);
    myPort.write(Cmd);
  }
  Cmd_old=Cmd;
  
//画面に文字を表示する．  
PFont font= createFont("MS Gothic", 24); 
textFont(font); 
text("Mode "+Cmd,160, 270); 

dmy=String.format("%d\n",Sx);
text("X:"+dmy,300,50);
dmy=String.format("%d\n",Sy);
text("Y:"+dmy,300,100);
dmy=String.format("%d\n",Sz);
text("Z:"+dmy,300,150);

image(myCapture, 0, 0);//キャプチャーイメージを表示するならコメントをとる
}


void controlEvent(ControlEvent theEvent) {
  int dmy;
  println(
  "## controlEvent / id:"+theEvent.controller().id()+
  " / name:"+theEvent.controller().name()+
  " / label:"+theEvent.controller().label()+
  " / value:"+theEvent.controller().value()
  );
  if(theEvent.controller().id()==0) {
  println("GO\n");
  Cmd ="G\n";
  }
  if(theEvent.controller().id()==1) {
  println("LEFT\n");
  Cmd = "L\n";
  }
  if(theEvent.controller().id()==2) {
  println("STOP");
  Cmd = "S\n";
  }
  if(theEvent.controller().id()==3) {
  println("Right");
  Cmd = "R\n";
  }
  if(theEvent.controller().id()==4) {
  println("Back");
  Cmd = "B\n";
  }
  if(theEvent.controller().id()==5) {
  dmy = (int)theEvent.controller().value();
  Cmd=String.format("s%03d\n",dmy);
  println(Cmd);
  }
}

void serialEvent(Serial p){
  int count = 3;//配列数
  //データフォーマットval,val,val\n
  
  //文字列の変数stringDataを用意
  //改行'\n'が来るまで読み込む
  String stringData=myPort.readStringUntil('\n');

  //文字列データが空ないとき
  if(stringData!=null){
    //文字列データに含まれる改行記号を取り除く
    stringData=trim(stringData);

    //整数型の配列data[]を用意し、
    //コンマ記号をもとに文字列データを区切って
    //配列data[]に整数化して入れておく
    int data[]=int(split(stringData,','));

    //配列data[]内のデータが３つなら、
    if(data.length==count){
      //最初のデータをxに代入
      Sx=data[0];
      //次のデータをyに代入
      Sy=data[1];
      //その次のデータをzに代入
      Sz=data[2];
    }
  }  
}

//キャプチャーイベントキャプチャーを行うならコメントを外す．

void captureEvent(Capture myCapture) {
  myCapture.read();
}

